Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.1.1.3.10.8.2.1
retrieving revision 1.1.1.3.10.8.2.2
diff -u -r1.1.1.3.10.8.2.1 -r1.1.1.3.10.8.2.2
--- squid/src/protos.h	22 Apr 2000 20:02:55 -0000	1.1.1.3.10.8.2.1
+++ squid/src/protos.h	2 May 2000 22:50:29 -0000	1.1.1.3.10.8.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.1.1.3.10.8.2.1 2000/04/22 20:02:55 hno Exp $
+ * $Id: protos.h,v 1.1.1.3.10.8.2.2 2000/05/02 22:50:29 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -45,6 +45,7 @@
 #if HEADERS_LOG
 extern void headersLog(int cs, int pq, method_t m, void *data);
 #endif
+char *log_quote(const char *header);
 
 extern aclCheck_t *aclChecklistCreate(const struct _acl_access *,
     request_t *,
Index: squid/src/pump.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/pump.c,v
retrieving revision 1.1.1.3.10.2
retrieving revision 1.1.1.3.10.2.2.1
diff -u -r1.1.1.3.10.2 -r1.1.1.3.10.2.2.1
--- squid/src/pump.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.2
+++ squid/src/pump.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.2.2.1
@@ -1,5 +1,6 @@
+
 /*
- * $Id: pump.c,v 1.1.1.3.10.2 2000/04/20 18:14:22 hno Exp $
+ * $Id: pump.c,v 1.1.1.3.10.2.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 61    PUMP handler
  * AUTHOR: Kostas Anagnostakis
Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.1.1.3.10.3
retrieving revision 1.1.1.3.10.3.2.1
diff -u -r1.1.1.3.10.3 -r1.1.1.3.10.3.2.1
--- squid/src/ssl.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.3
+++ squid/src/ssl.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.1.1.3.10.3 2000/04/20 18:14:23 hno Exp $
+ * $Id: ssl.c,v 1.1.1.3.10.3.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -377,13 +377,15 @@
     SslStateData *sslState = data;
     request_t *request = sslState->request;
     ErrorState *err = NULL;
-    if (sslState->servers->peer) {
+    if (sslState->servers->peer)
 	hierarchyNote(&sslState->request->hier, sslState->servers->code,
 	    sslState->servers->peer->host);
-    } else {
+    else if (Config.onoff.log_ip_on_direct)
 	hierarchyNote(&sslState->request->hier, sslState->servers->code,
 		fd_table[sslState->server.fd].ipaddr);
-    }
+    else
+	hierarchyNote(&sslState->request->hier, sslState->servers->code,
+		sslState->host);
     if (status == COMM_ERR_DNS) {
 	debug(26, 4) ("sslConnect: Unknown host: %s\n", sslState->host);
 	err = errorCon(ERR_DNS_FAIL, HTTP_NOT_FOUND);
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.1.1.3.10.8
retrieving revision 1.1.1.3.10.8.2.1
diff -u -r1.1.1.3.10.8 -r1.1.1.3.10.8.2.1
--- squid/src/store.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.8
+++ squid/src/store.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.8.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.1.1.3.10.8 2000/04/20 18:14:23 hno Exp $
+ * $Id: store.c,v 1.1.1.3.10.8.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -804,11 +804,12 @@
 	     * we'll just call storeUnlockObject() on these.
 	     */
 	    e->lock_count++;
+	    EBIT_SET(e->flags, RELEASE_REQUEST);
 	    stackPush(&LateReleaseStack, e);
+	    return;
 	} else {
 	    destroy_StoreEntry(e);
 	}
-	return;
     }
     storeLog(STORE_LOG_RELEASE, e);
     if (e->swap_filen > -1) {
Index: squid/src/store_client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_client.c,v
retrieving revision 1.1.1.3.10.4
retrieving revision 1.1.1.3.10.4.2.1
diff -u -r1.1.1.3.10.4 -r1.1.1.3.10.4.2.1
--- squid/src/store_client.c	21 Apr 2000 22:18:06 -0000	1.1.1.3.10.4
+++ squid/src/store_client.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.4.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_client.c,v 1.1.1.3.10.4 2000/04/21 22:18:06 hno Exp $
+ * $Id: store_client.c,v 1.1.1.3.10.4.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Client-Side Interface
  * AUTHOR: Duane Wessels
@@ -258,9 +258,6 @@
 {
     MemObject *mem = e->mem_obj;
     size_t sz;
-    mem_node *mp = mem->data_hdr.head;
-    off_t mp_ofs = mem->data_hdr.origin_offset;
-    off_t offset;
 
     if (storeClientNoMoreToSend(e, sc)) {
 	/* There is no more to send! */
@@ -309,68 +306,10 @@
     if (sc->copy_offset >= mem->inmem_lo && sc->copy_offset < mem->inmem_hi) {
 	/* What the client wants is in memory */
 	debug(20, 3) ("storeClientCopy3: Copying from memory\n");
-        /*
-	 * We are now throwing data to clients in SM_PAGE_SIZE chunks, following
-	 * the mem_node linked list just like src/store_swapout.c does. We send
-	 * data to a client when we have at least a page to send, and we only
-	 * send partial pages when we have the entire object in memory. We then
-	 * throw the buffer to the callback, and let the callback routine use the
-	 * buffer directly rather than copy and waste memory. Yes, evil, but thats
-	 * life, right?
-	 */
-
-        /* Fudge to figure out whether we're doing the old or new style call */
-        if (sc->copy_buf != NULL) {
-            /* Old style */
-	    sz = stmemCopy(&mem->data_hdr,
-		sc->copy_offset, sc->copy_buf, sc->copy_size);
-	    storeClientCallback(sc, sz);
-	    return;
-	} else {
-	    /* XXX Traverse the membuf list, find the memnode and offset,
-             * and use that buffer. We still end up walking the list :( ..
-             * its a temporary hack. When the code works, I'd like to do this:
-	     *
-	     * - if we don't have a 'hint' mem_node *, we traverse the list
-             *   and look for it
-	     * - if we do have a hint mem_node *, we use it as the basis 
-             *   for figuring out the next mem_node to look at, and if we
-             *   can't figure it out, just fallback to the route search.
-	     */
-
-            /* Whats the offset? :-) */
-	    offset = sc->copy_offset;
-            /* XXX THIS SHOULD BE IN STMEM.C!!!! */
-	    while ((mp_ofs + mp->len - 1) < offset) {
-	        mp_ofs += mp->len;
-	        if (!mp->next) {
-	   	    /* No match */
-		    mp = NULL;
-		    break;
-	        }
-	        assert(mp->next);
-	        mp = mp->next;
-	    }
-
-	    /* If we don't have a membuf pointer here, we are fucked */
-	    assert(mp);
-
-	    /*
-	     * Ok, we have mp_ofs with the offset of this mem_node, and mp
-	     * which is the current memnode. The offset inside the memnode
-	     * we need to be is offset - mp_ofs, and the length of the data
-             * we are handing off is mp->len - sz.
-	     */
-	    sz = offset - mp_ofs;
-
-	    /* Call the callback with the buffer */
-	    sc->flags.disk_io_pending = 0;
-            debug(20, 5) ("storeClientCopy2: copy_offset = %d, seen_offset = %d\n", sc->copy_offset, sc->seen_offset);
-            debug(20, 5) ("storeClientCopy2: copying %d bytes of data from offset %d in the membuf of size %d\n", mp->len - sz, sz, mp->len);
-	    sc->copy_buf = mp->data + sz;
-	    storeClientCallback(sc, mp->len - sz);
-	    return;
-	}
+	sz = stmemCopy(&mem->data_hdr,
+  	sc->copy_offset, sc->copy_buf, sc->copy_size);
+        storeClientCallback(sc, sz);
+        return;
     }
     /* What the client wants is not in memory. Schedule a disk read */
     assert(STORE_DISK_CLIENT == sc->type);
@@ -448,7 +387,7 @@
 	return;
     }
     if (tlv_list == NULL) {
-	debug(20, 1) ("WARNING: failed to unpack swapfile meta data\n");
+	debug(20, 1) ("WARNING: failed to unpack meta data\n");
 	storeClientCallback(sc, -1);
 	return;
     }
Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.3.10.6
retrieving revision 1.1.1.3.10.6.2.1
diff -u -r1.1.1.3.10.6 -r1.1.1.3.10.6.2.1
--- squid/src/store_dir.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.6
+++ squid/src/store_dir.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.6.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.3.10.6 2000/04/20 18:14:23 hno Exp $
+ * $Id: store_dir.c,v 1.1.1.3.10.6.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -182,83 +182,50 @@
 storeDirSelectSwapDir(const StoreEntry *e)
 {
     size_t objsize;
-    size_t least_size = -1;
-    size_t least_maxobjsize = -1;
-    double high = (double) Config.Swap.highWaterMark / 100.0;
-    double u;
-    int dirn;
+    size_t least_size;
+    size_t least_objsize;
+    int least_load = 1000;
+    int load;
+    int dirn = -1;
     int i;
     SwapDir *SD;
 
-    /*
-     * Handle simplest case of a single swap directory immediately
-     * XXX You'd hope to hell that its a valid one, or something is
-     * definitely wrong.
-     */
-    if (Config.cacheSwap.n_configured == 1)
-        return 0;
-
     /* Calculate the object size */
     objsize = objectLen(e);
     if (objsize != -1)
 	objsize += e->mem_obj->swap_hdr_sz;
- 
-    /*
-     * Go through the list of store dirs, doing the following:
-     * - if its read only, ignore it
-     * - if its over the high water mark, ignore it
-     * - if its not valid for the object size, ignore it
-     * - if the checkobj routine returns false, ignore it
-     * - if its got a smaller maxobjsize than the last match, use it
-     */
-    dirn = -1;
+    /* Initial defaults */
+    least_size = Config.cacheSwap.swapDirs[0].cur_size;
+    least_objsize = Config.cacheSwap.swapDirs[0].max_objsize;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
         SD = &Config.cacheSwap.swapDirs[i];
-        SD->flags.selected = 0;
- 
-        /* Read only check */
+	SD->flags.selected = 0;
         if (SD->flags.read_only)
             continue;
- 
-        /* Over high water mark check */
-        u = (double) SD->cur_size / SD->max_size;
-        if (u > high)
-            continue;
-    
         /* Valid for object size check */
         if (!storeDirValidSwapDirSize(i, objsize))
             continue;
-
-        /* Will the filesystem actually store this object ? */
-	if (!SD->checkobj(SD, e))
+        load = SD->checkobj(SD, e);
+        if (load < 0)
 	    continue;
-
-        /* Is this maxobjsize smaller? */
-        if ((least_maxobjsize == -1) || (SD->max_objsize < least_maxobjsize)) {
-            least_maxobjsize = SD->max_objsize;
-            least_size = SD->cur_size;
-            dirn = i;
+        if (SD->cur_size > SD->max_size)
+            continue;
+        if (load > least_load)
+            continue;
+        if ((least_objsize > 0) && (objsize > least_objsize))
             continue;
-        }
-       
-        /* Does this device have more free space? */
-        if ((least_size == -1) || (SD->cur_size < least_size)) {
-            least_size = SD->cur_size;
-            dirn = i;
+        /* Only use leastsize if the load is equal */
+        if ((load == least_load) && (SD->cur_size > least_size))
             continue;
-        }
+        least_load = load;
+        least_size = SD->cur_size;
+        dirn = i;
     }
 
-    /* Now, if dirn isn't -1, we can use it */
-    if (dirn != -1) {
-        Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
-        return (dirn);
-    }
+    if (dirn >= 0)
+	Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
 
-    /*
-     * If we didn't find anything valid, return so.
-     */
-    return (-1);
+    return dirn;
 }
 
 
@@ -331,9 +298,11 @@
 
     /* Now go through each swapdir, calling its statfs routine */
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-      storeAppendPrintf(sentry, "\n");
-      SD = &(Config.cacheSwap.swapDirs[i]);
-      SD->statfs(SD, sentry);
+        storeAppendPrintf(sentry, "\n");
+        SD = &(Config.cacheSwap.swapDirs[i]);
+        storeAppendPrintf(sentry, "Store Directory #%d (%s): %s\n", i, SD->type,
+          storeSwapDir(i));
+        SD->statfs(SD, sentry);
     }
 }
 
@@ -473,12 +442,13 @@
 void
 storeDirSync(void)
 {
-    int i = 0;
+    int i;
+    SwapDir *SD;
 
-    while (storefs_list[i].typestr != NULL) {
-	if (storefs_list[i].syncfunc != NULL) 
-            storefs_list[i].syncfunc();
-	i++;
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        SD = &Config.cacheSwap.swapDirs[i];
+        if (SD->sync != NULL)
+            SD->sync(SD);
     }
 }
 
@@ -488,12 +458,13 @@
 void
 storeDirCallback(void)
 {
-    int i = 0;
+    int i;
+    SwapDir *SD;
 
-    while (storefs_list[i].typestr != NULL) {
-	if (storefs_list[i].callbackfunc != NULL)
-            storefs_list[i].callbackfunc();
-	i++;
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        SD = &Config.cacheSwap.swapDirs[i];
+        if (SD->callback != NULL)
+            SD->callback(SD);
     }
 }
 
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.10.8.2.3
retrieving revision 1.1.1.3.10.8.2.4
diff -u -r1.1.1.3.10.8.2.3 -r1.1.1.3.10.8.2.4
--- squid/src/structs.h	23 Apr 2000 09:55:37 -0000	1.1.1.3.10.8.2.3
+++ squid/src/structs.h	2 May 2000 22:50:29 -0000	1.1.1.3.10.8.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.10.8.2.3 2000/04/23 09:55:37 hno Exp $
+ * $Id: structs.h,v 1.1.1.3.10.8.2.4 2000/05/02 22:50:29 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -311,9 +311,7 @@
 #if USE_ICMP
 	char *pinger;
 #endif
-#if USE_UNLINKD
 	char *unlinkd;
-#endif
     } Program;
 #if USE_DNSSERVERS
     int dnsChildren;
@@ -416,6 +414,8 @@
 #if USE_CACHE_DIGESTS
 	int digest_generation;
 #endif
+	int log_ip_on_direct;
+	int authenticateIpTTLStrict;
     } onoff;
     acl *aclList;
     struct {
@@ -1384,6 +1384,8 @@
     /* These two are notifications */
     STREFOBJ *refobj;		/* Reference this object */
     STUNREFOBJ *unrefobj;	/* Unreference this object */
+    STCALLBACK *callback;	/* Handle pending callbacks */
+    STSYNC *sync;		/* Sync the directory */
     struct {
         STOBJCREATE *create;
 	STOBJOPEN *open;
@@ -1875,8 +1877,6 @@
     STFSPARSE *parsefunc;
     STFSRECONFIGURE *reconfigurefunc;
     STFSSHUTDOWN *donefunc;
-    STFSCALLBACK *callbackfunc;
-    STFSSYNC *syncfunc;
 };
 
 typedef struct chunked_tag
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.10.6
retrieving revision 1.1.1.3.10.6.2.1
diff -u -r1.1.1.3.10.6 -r1.1.1.3.10.6.2.1
--- squid/src/typedefs.h	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.6
+++ squid/src/typedefs.h	2 May 2000 22:50:29 -0000	1.1.1.3.10.6.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.1.1.3.10.6 2000/04/20 18:14:23 hno Exp $
+ * $Id: typedefs.h,v 1.1.1.3.10.6.2.1 2000/05/02 22:50:29 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -238,6 +238,8 @@
 typedef void STUNREFOBJ(SwapDir *, StoreEntry *);
 typedef void STSETUP(storefs_entry_t *);
 typedef void STDONE(void);
+typedef void STCALLBACK(SwapDir *);
+typedef void STSYNC(SwapDir *);
 
 typedef storeIOState *STOBJCREATE(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
 typedef storeIOState *STOBJOPEN(SwapDir *, StoreEntry *, STFNCB *, STIOCB *, void *);
@@ -258,8 +260,6 @@
 typedef void STFSRECONFIGURE(SwapDir *, int, char *);
 typedef void STFSSTARTUP(void);
 typedef void STFSSHUTDOWN(void);
-typedef void STFSCALLBACK(void);
-typedef void STFSSYNC(void);
 
 typedef double hbase_f(double);
 typedef void StatHistBinDumper(StoreEntry *, int idx, double val, double size, int count);
Index: squid/src/unlinkd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/unlinkd.c,v
retrieving revision 1.1.1.3.10.3.2.1
retrieving revision 1.1.1.3.10.3.2.2
diff -u -r1.1.1.3.10.3.2.1 -r1.1.1.3.10.3.2.2
--- squid/src/unlinkd.c	22 Apr 2000 20:02:55 -0000	1.1.1.3.10.3.2.1
+++ squid/src/unlinkd.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.2
@@ -1,5 +1,6 @@
+
 /*
- * $Id: unlinkd.c,v 1.1.1.3.10.3.2.1 2000/04/22 20:02:55 hno Exp $
+ * $Id: unlinkd.c,v 1.1.1.3.10.3.2.2 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 12    Unlink Daemon
  * AUTHOR: Duane Wessels
Index: squid/src/fs/aufs/async_io.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/async_io.c,v
retrieving revision 1.1.6.1.2.2
retrieving revision 1.1.6.1.2.3
diff -u -r1.1.6.1.2.2 -r1.1.6.1.2.3
--- squid/src/fs/aufs/async_io.c	24 Apr 2000 22:13:02 -0000	1.1.6.1.2.2
+++ squid/src/fs/aufs/async_io.c	2 May 2000 22:50:29 -0000	1.1.6.1.2.3
@@ -220,7 +220,8 @@
 	errno = EWOULDBLOCK;
 	if (callback)
 	    (callback) (fd, callback_data, -1, errno);
-	free_func(bufp);
+	if (free_func)
+            free_func(bufp);
 	return;
     }
     ctrlp = memPoolAlloc(aio_ctrl_pool);
@@ -350,7 +351,7 @@
 
 
 void
-aioCheckCallbacks(void)
+aioCheckCallbacks(SwapDir *SD)
 {
     aio_result_t *resultp;
     aio_ctrl_t *ctrlp;
@@ -408,14 +409,14 @@
 
 /* Flush all pending I/O */
 void
-aioSync(void)
+aioSync(SwapDir *SD)
 {
     if (!initialised)
 	return;			/* nothing to do then */
     /* Flush all pending operations */
     debug(32, 1) ("aioSync: flushing pending I/O operations\n");
     do {
-	aioCheckCallbacks();
+	aioCheckCallbacks(SD);
     } while (aio_sync());
     debug(32, 1) ("aioSync: done\n");
 }
Index: squid/src/fs/aufs/store_asyncufs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/store_asyncufs.h,v
retrieving revision 1.1.6.3
retrieving revision 1.1.6.3.2.1
diff -u -r1.1.6.3 -r1.1.6.3.2.1
--- squid/src/fs/aufs/store_asyncufs.h	11 Apr 2000 18:18:41 -0000	1.1.6.3
+++ squid/src/fs/aufs/store_asyncufs.h	2 May 2000 22:50:29 -0000	1.1.6.3.2.1
@@ -13,6 +13,8 @@
 #define NUMTHREADS 16
 #endif
 
+#define MAGIC1 (NUMTHREADS/Config.cacheSwap.n_configured/2)
+
 struct _aio_result_t {
     int aio_return;
     int aio_errno;
@@ -45,8 +47,8 @@
 void aioRead(int, int offset, char *, int size, AIOCB *, void *);
 void aioStat(char *, struct stat *, AIOCB *, void *);
 void aioUnlink(const char *, AIOCB *, void *);
-void aioCheckCallbacks(void);
-void aioSync(void);
+void aioCheckCallbacks(SwapDir *);
+void aioSync(SwapDir *);
 int aioQueueSize(void); 
 
 struct _aioinfo_t {
@@ -77,9 +79,12 @@
 extern MemPool * aio_state_pool;
 
 extern void storeAufsDirMapBitReset(SwapDir *, sfileno);
+extern int storeAufsDirMapBitAllocate(SwapDir *);
 
 extern char * storeAufsDirFullPath(SwapDir *SD, sfileno filn, char *fullpath);
 extern void storeAufsDirUnlinkFile(SwapDir *, sfileno);
+extern void storeAufsDirReplAdd(SwapDir *SD, StoreEntry *);
+extern void storeAufsDirReplRemove(StoreEntry *);
 
 /*
  * Store IO stuff
Index: squid/src/fs/aufs/store_dir_aufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/store_dir_aufs.c,v
retrieving revision 1.1.6.6.2.1
retrieving revision 1.1.6.6.2.2
diff -u -r1.1.6.6.2.1 -r1.1.6.6.2.2
--- squid/src/fs/aufs/store_dir_aufs.c	22 Apr 2000 20:02:55 -0000	1.1.6.6.2.1
+++ squid/src/fs/aufs/store_dir_aufs.c	2 May 2000 22:50:29 -0000	1.1.6.6.2.2
@@ -71,7 +71,6 @@
 
 static int n_asyncufs_dirs = 0;
 static int *asyncufs_dir_index = NULL;
-MemPool * aio_state_pool = NULL;
 
 static char *storeAufsDirSwapSubDir(SwapDir *, int subdirn);
 static int storeAufsDirCreateDirectory(const char *path, int);
@@ -108,6 +107,7 @@
 static STMAINTAINFS storeAufsDirMaintain;
 static STCHECKOBJ storeAufsDirCheckObj;
 static STREFOBJ storeAufsDirRefObj;
+static STUNREFOBJ storeAufsDirUnrefObj;
 static QS rev_int_sort;
 static int storeAufsDirClean(int swap_index);
 static EVH storeAufsDirCleanEvent;
@@ -155,6 +155,18 @@
     aioinfo = (aioinfo_t *)SD->fsdata;
     file_map_bit_reset(aioinfo->map, filn);
 }
+
+int
+storeAufsDirMapBitAllocate(SwapDir *SD)
+{
+    aioinfo_t *aioinfo = (aioinfo_t *)SD->fsdata;
+    int fn;
+    fn = file_map_allocate(aioinfo->map, aioinfo->suggest);
+    file_map_bit_set(aioinfo->map, fn);
+    aioinfo->suggest = fn + 1;
+    return fn;
+}
+
     
 /*
  * Initialise the asyncufs bitmap
@@ -272,18 +284,28 @@
 storeAufsDirSwapLogFile(SwapDir * sd, const char *ext)
 {
     LOCAL_ARRAY(char, path, SQUID_MAXPATHLEN);
+    LOCAL_ARRAY(char, pathtmp, SQUID_MAXPATHLEN);
     LOCAL_ARRAY(char, digit, 32);
+    char *pathtmp2;
     if (Config.Log.swap) {
-	xstrncpy(path, Config.Log.swap, SQUID_MAXPATHLEN - 64);
-	strcat(path, ".");
-	snprintf(digit, 32, "%02d", sd->index);
-	strncat(path, digit, 3);
+        xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
+        while (index(pathtmp,'/'))
+            *index(pathtmp,'/')='.';
+        while (strlen(pathtmp) && pathtmp[strlen(pathtmp)-1]=='.')
+            pathtmp[strlen(pathtmp)-1]= '\0';
+        for(pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+        snprintf(path, SQUID_MAXPATHLEN-64, Config.Log.swap, pathtmp2);
+        if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
+            strcat(path, ".");
+            snprintf(digit, 32, "%02d", sd->index);
+            strncat(path, digit, 3);
+        }
     } else {
-	xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
-	strcat(path, "/swap.state");
+        xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
+        strcat(path, "/swap.state");
     }
     if (ext)
-	strncat(path, ext, 16);
+        strncat(path, ext, 16);
     return path;
 }
 
@@ -409,6 +431,7 @@
 	tlv_list = storeSwapMetaUnpack(hdr_buf, &swap_hdr_len);
 	if (tlv_list == NULL) {
 	    debug(20, 1) ("storeAufsDirRebuildFromDirectory: failed to get meta data\n");
+	    /* XXX shouldn't this be a call to storeAufsUnlink ? */
 	    storeAufsDirUnlinkFile(SD, sfileno);
 	    continue;
 	}
@@ -528,10 +551,12 @@
 		 * because adding to store_swap_size happens in
 		 * the cleanup procedure.
 		 */
-		storeExpireNow(e);
-		storeReleaseRequest(e);
+                storeExpireNow(e);
+                storeReleaseRequest(e);
+                storeAufsDirReplRemove(e);
+		storeRelease(e);
 		if (e->swap_filen > -1) {
-		    storeAufsDirMapBitReset(SD, e->swap_filen);
+		    /* Fake a unlink here, this is a bad hack :( */
 		    e->swap_filen = -1;
                     e->swap_dirn = -1;
 		}
@@ -579,6 +604,7 @@
 		e->refcount += s.refcount;
 #if HEAP_REPLACEMENT
 		storeHeapPositionUpdate(e, SD);
+		storeAufsDirUnrefObj(SD, e);
 #endif
 	    } else {
 		debug_trap("storeAufsDirRebuildFromSwapLog: bad condition");
@@ -613,10 +639,12 @@
 	} else if (e) {
 	    /* key already exists, this swapfile not being used */
 	    /* junk old, load new */
-	    storeExpireNow(e);
-	    storeReleaseRequest(e);
+            storeExpireNow(e);
+            storeReleaseRequest(e);
+            storeAufsDirReplRemove(e);
+	    storeRelease(e);
 	    if (e->swap_filen > -1) {
-		storeAufsDirMapBitReset(SD, e->swap_filen);
+		/* Fake a unlink here, this is a bad hack :( */
 		e->swap_filen = -1;
                 e->swap_dirn = -1;
 	    }
@@ -772,16 +800,7 @@
     EBIT_CLR(e->flags, ENTRY_VALIDATED);
     storeAufsDirMapBitSet(SD, e->swap_filen);
     storeHashInsert(e, key);	/* do it after we clear KEY_PRIVATE */
-#if HEAP_REPLACEMENT
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-	(void) 0;
-    } else {
-	e->repl.node = heap_insert(SD->repl.heap.heap, e);
-	debug(20, 4) ("storeAufsAddDiskRestore: inserted node %p\n", e->repl.node);
-    }
-#else
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-#endif
+    storeAufsDirReplAdd(SD, e);
     return e;
 }
 
@@ -1389,22 +1408,39 @@
     last_warn_time = squid_curtime;
 }
 
-/* 
+/*
  * storeAufsDirCheckObj
  *
  * This routine is called by storeDirSelectSwapDir to see if the given
  * object is able to be stored on this filesystem. AUFS filesystems will
- * happily store anything. We don't check for maxobjsize here since its
- * done by the upper layers.
+ * happily store anything as long as the LRU time isn't too small.
  */
 int
 storeAufsDirCheckObj(SwapDir *SD, const StoreEntry *e)
 {
-    return 1;
+    int loadav;
+    int ql;
+
+#if !HEAP_REPLACEMENT
+    if (storeAufsDirExpiredReferenceAge(SD) < 300) {
+	debug(20, 3) ("storeAufsDirCheckObj: NO: LRU Age = %d\n",
+	    storeAufsDirExpiredReferenceAge(SD));
+	/* store_check_cachable_hist.no.lru_age_too_low++; */
+	return -1;
+    }
+#endif
+    ql = aioQueueSize();
+    if (ql == 0)
+        loadav = 0;
+    else if (ql >= MAGIC1) /* Queue is too long, don't even consider it */
+        loadav = -1;
+    else
+        loadav = MAGIC1 * 1000 / ql;
+    return loadav;
 }
 
 /*
- * storeAfsDirRefObj
+ * storeAufsDirRefObj
  *
  * This routine is called whenever an object is referenced, so we can
  * maintain replacement information within the storage fs.
@@ -1412,27 +1448,47 @@
 void
 storeAufsDirRefObj(SwapDir *SD, StoreEntry *e)
 {
-#ifdef HEAP_REPLACEMENT
+    debug(1, 3) ("storeAufsDirRefObj: referencing %d/%d\n", e->swap_dirn,
+      e->swap_filen);
+#if HEAP_REPLACEMENT
     /* Nothing to do here */
 #else
     /* Reference the object */
-    debug(1, 3) ("storeAufsDirRefObj: referencing %d/%d\n", e->swap_dirn, e->swap_filen);
-    dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
+    if (!EBIT_TEST(e->flags, RELEASE_REQUEST) &&
+        !EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
+        dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
+        dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
+    }
 #endif
 }
 
 /*
- * storeAufsDirUnlikFile
+ * storeAufsDirUnrefObj
+ * This routine is called whenever the last reference to an object is
+ * removed, to maintain replacement information within the storage fs.
+ */
+void
+storeAufsDirUnrefObj(SwapDir *SD, StoreEntry *e)
+{
+    debug(1, 3) ("storeAufsDirUnrefObj: referencing %d/%d\n", e->swap_dirn,
+      e->swap_filen);
+#if HEAP_REPLACEMENT
+    if (e->repl.node)
+	heap_update(SD->repl.heap.heap, e->repl.node, e);
+#endif
+}
+
+/*
+ * storeAufsDirUnlinkFile
  *
  * This routine unlinks a file and pulls it out of the bitmap.
- * It used to be in storeUfsUnlink(), however an interface change
+ * It used to be in storeAufsUnlink(), however an interface change
  * forced this bit of code here. Eeek.
  */
 void
 storeAufsDirUnlinkFile(SwapDir *SD, sfileno f)
 {
-    debug(79, 3) ("storeUfsDirUnlinkFile: unlinking fileno %08X\n", f);
+    debug(79, 3) ("storeAufsDirUnlinkFile: unlinking fileno %08X\n", f);
     storeAufsDirMapBitReset(SD, f);
     aioUnlink(storeAufsDirFullPath(SD, f, NULL), NULL, NULL);
 }
@@ -1470,8 +1526,8 @@
     age = (time_t) (z * 60.0);
     if (age < 60)
 	age = 60;
-    else if (age > 31536000)
-	age = 31536000;
+    else if (age > Config.referenceAge)
+	age = Config.referenceAge;
     return age;
 }
 #endif
@@ -1507,8 +1563,51 @@
 #endif
 }
 
+/*
+ * Add and remove the given StoreEntry from the replacement policy in
+ * use.
+ */
+
+void
+storeAufsDirReplAdd(SwapDir *SD, StoreEntry *e)
+{
+    debug(20, 4) ("storeUfsDirReplAdd: added node %p to dir %d\n", e,
+      SD->index);
+#if HEAP_REPLACEMENT
+    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
+        (void) 0;
+    } else {
+        e->repl.node = heap_insert(SD->repl.heap.heap, e);
+        debug(20, 4) ("storeUfsDirReplAdd: inserted node 0x%x\n", e->repl.node);
+    }
+#else
+    /* Shouldn't we not throw special objects into the lru ? */
+    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
+#endif
+}
+
+
+void
+storeAufsDirReplRemove(StoreEntry *e)
+{
+    SwapDir *SD = INDEXSD(e->swap_dirn);
+    debug(20, 4) ("storeUfsDirReplRemove: remove node %p from dir %d\n", e,
+      SD->index);
+#if HEAP_REPLACEMENT
+    /* And now, release the object from the replacement policy */
+    if (e->repl.node) {
+        debug(20, 4) ("storeUfsDirReplRemove: deleting node 0x%x\n",
+          e->repl.node);
+        heap_delete(SD->repl.heap.heap, e->repl.node);
+        e->repl.node = NULL;
+    }
+#else
+    dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
+#endif
+}
+
 
-/* ========= LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
+/* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
 
 void
 storeAufsDirStats(SwapDir *SD, StoreEntry * sentry)
@@ -1518,7 +1617,6 @@
     struct statvfs sfs;
 #endif
     aioinfo = (aioinfo_t *)SD->fsdata;
-    storeAppendPrintf(sentry, "Store Directory #%d: %s\n", SD->index, SD->path);
     storeAppendPrintf(sentry, "First level subdirectories: %d\n", aioinfo->l1);
     storeAppendPrintf(sentry, "Second level subdirectories: %d\n", aioinfo->l2);
     storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
@@ -1548,6 +1646,15 @@
     if (SD->flags.read_only)
         storeAppendPrintf(sentry, " READ-ONLY");
     storeAppendPrintf(sentry, "\n");
+#if !HEAP_REPLACEMENT
+    storeAppendPrintf(sentry, "LRU Expiration Age: %6.2f days\n",
+	(double) storeAufsDirExpiredReferenceAge(SD) / 86400.0);
+#else
+#if 0
+    storeAppendPrintf(sentry, "Storage Replacement Threshold:\t%f\n",
+	heap_peepminkey(sd.repl.heap.heap));
+#endif
+#endif
 }
 
 /*
@@ -1730,6 +1837,9 @@
     sd->maintainfs = storeAufsDirMaintain;
     sd->checkobj = storeAufsDirCheckObj;
     sd->refobj = storeAufsDirRefObj;
+    sd->unrefobj = storeAufsDirUnrefObj;
+    sd->callback = aioCheckCallbacks;
+    sd->sync = aioSync;
     sd->obj.create = storeAufsCreate;
     sd->obj.open = storeAufsOpen;
     sd->obj.close = storeAufsClose;
@@ -1782,7 +1892,5 @@
     storefs->parsefunc = storeAufsDirParse;
     storefs->reconfigurefunc = storeAufsDirReconfigure;
     storefs->donefunc = aioDone;
-    storefs->callbackfunc = aioCheckCallbacks;
-    storefs->syncfunc = aioSync;
     aioInit();
 }
